/** GStundiscret
 *
 * A simple nagravideo decrypt plugin for gstreamer0.10
 *
 *   Copyright (C) 2006  megabibi@gmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */


#ifndef __GST_UNDISCRET_H__
#define __GST_UNDISCRET_H__

#include <gst/gst.h>

G_BEGIN_DECLS

/* #defines don't like whitespacey bits */
#define GST_TYPE_UNDISCRET \
  (gst_undiscret_get_type())
#define GST_UNDISCRET(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),GST_TYPE_UNDISCRET,Gstundiscret))
#define GST_UNDISCRET_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),GST_TYPE_UNDISCRET,GstundiscretClass))
#define GST_IS_PLUGIN_TEMPLATE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),GST_TYPE_UNDISCRET))
#define GST_IS_PLUGIN_TEMPLATE_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),GST_TYPE_UNDISCRET))

typedef struct _Gstundiscret      Gstundiscret;
typedef struct _GstundiscretClass GstundiscretClass;

struct YUY2twopixels
{
  guint8 Y0;
  guint8 U0;
  guint8 Y1;
  guint8 V0;
};



struct _Gstundiscret
{
  GstElement element;

  GstPad *sinkpad, *srcpad;

  gboolean silent;

  int width,height;

  struct YUY2twopixels  red,green,blue;
  int thr;          // seuil correspondant à une image "noir" pour la composante Y
  int n_blck_pixel; // number of black pixel wich corresponds to an elementary  right shift
  double percent;   // [0 1.0] : percentage of the image used for the evaluation of the distance ///TODO should be a parameter
  int step;
  int rightmargin;

  int * depl2;
  int * depl;
  int * depl_confidence;
  int * depl2cf;


};

struct _GstundiscretClass 
{
  GstElementClass parent_class;
};

GType gst_undiscret_get_type (void);

G_END_DECLS

#endif /* __GST_UNDISCRET_H__ */
